// **************************************************************************
// ROOT macro: plot_total.c
// Plots the figures of total pair production cross section data. 
// There is one figure (now in png format, it can be modified) per element.
// -	cross section data of EPICS2014 (Z: 1-100) 
// -	cross section data of Livermore (Z: 1-99)   
// -	comparison of cross section data between Livermore and EPICS2014 (Z: 1-99) 
// The generated figures are saved in the corresponding directory:
// -	plots/total/comparison
// -	plots/total/epics2017
// -	plots/total/livermore

// Authors: Zhuxin LI @CENBG,France
// 2019.12.09
// **************************************************************************
TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
 	double RatioMax3[100];
	double RatioMax3_x[100];
	double RatioMax4[100];
	double RatioMax4_x[100];
  
enum DataToPlot
{
	
	Data2014,
	Data2017
	  	 
};
  
struct Info
{
 Info(int Z, int sub, double r1, double r2)
 :z(Z), subshellIndex(sub), ratio1Max(r1), ratio2Max(r2){}
 int z;
 int subshellIndex;
 double ratio1Max; // for low fit
 double ratio2Max; // for high fit
}; 
 
std::map<int, double> ratioMax;
  
int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;
int results4=0;
int results5=0;
std::vector<int> results5V;
int results6=0;
std::vector<int> results6V;
int results7=0;
std::vector<int> results7V;
int results8=0;
int results9=0;
	

// void plotMaximalDifferenceOfFittedScatteringFunctionWithZ_2017_2014(){
	
	// gROOT->Reset();	
	// gSystem->Exec("mkdir -p plots/");
	


	// double r_1[100]; 
	// double r_2[100]; 
	
	
	// double R_1[100]; 
	// double R_2[100]; 
	// double x[100];
	


	// double r1, r2, R1, R2;	
	// double sum1, sum2, Sum1, Sum2;
	// int z;
	// std::ostringstream ost;
	// ost <<"MaximalDifferenceOfSFFits_2017_2014_final.dat";
	// std::ifstream fin(ost.str().c_str());
	// for(int i = 0; i<100;i++) // 1612 lines 
	// {
		
		// fin >> z >> r1 >> r2 >>R1 >> R2;
		// x[i] = z;
		// r_1[i] = r1;
		// r_2[i] = r2;
		// R_1[i] = R1;
		// R_2[i] = R2;
		// sum1+=abs((R1/r1));
		// sum2+=abs((R2/r2));
		
		
		// // cout<<z<<" "<<r1<<endl;
	// }
	// printf("factor on average for region 1 = %.9e\n", sum1/100);
	// printf("factor on average for region 2 = %.9e\n", sum2/100);
	// fin.close();
	
	
	// gROOT->Reset();
	
	
	// TCanvas* mycanvas = new TCanvas("g","Form Factors",800, 50, 800,600);
		
	// mycanvas->SetGrid();
	
	// mycanvas->Divide(1,2);
	// mycanvas->cd(1);
	
	// // gPad->SetLogx();
	// // gPad->SetLogy();
	// gPad->SetBottomMargin(0.15);
	// gPad->SetLeftMargin(0.15);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
					
	// auto mg = new TMultiGraph();
	// TGraph *graph1 = new TGraph(100,x,r_1);		
	// TGraph *graph1_g4 = new TGraph(100,x,R_1);		
		
		
		
	
	// //region 3
	// graph1->SetMarkerStyle(24);  // red point
	// graph1->SetMarkerSize(1);
	// graph1->SetMarkerColor(kRed);
	// //graph1->SetLineWidth(2);
	// graph1->SetLineColor(kRed);	
	// mg->Add(graph1);	
	// //region 3
	
	// graph1_g4->SetMarkerStyle(24);  // red point
	// graph1_g4->SetMarkerSize(1);
	// graph1_g4->SetMarkerColor(kBlue);
	// //graph1_g4->SetLineWidth(2);
	// graph1_g4->SetLineColor(kBlue);	
	// mg->Add(graph1_g4);		
		
		// // // //set graph parameters of livermore
		
		
	// mg->Draw("AP");
			
	// mg->SetTitle("Maximal difference of fits in region 1 according to Z");		
	// mg->GetXaxis()->SetTitle("Atomic number Z");
	// mg->GetYaxis()->SetTitle("Relative difference (%)");
	
	// mg->GetXaxis()->SetTitleSize(0.06);
	// mg->GetYaxis()->SetTitleSize(0.06);
	
	// mg->GetXaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelOffset(1.3);
	
	
	// mg->GetXaxis()->CenterTitle();
	// mg->GetYaxis()->CenterTitle();
	// mg->GetXaxis()->SetLimits(0, 101);
	
	// TLegend* leg1 = new TLegend(0.65,0.15,0.9,0.35);
	// // leg1->SetTextAlign(12);
	// // leg1->SetFillColor(0);
	// // leg1->SetFillStyle(0);		
	// leg1->SetTextSize(0.04);
	
	// TString rname1 = "Present work (Poly 1)";
	// TString rname2 = "Geant4 10.07 version (Poly 1)";
	
	
	
	// leg1->AddEntry(graph1,rname1);
	// leg1->AddEntry(graph1_g4,rname2);
	// // leg1->AddEntry(graph14,rname14);
	
	// // leg1->AddEntry(graph24,rname24);
	
	// // leg1->DrawClone("Same");
	// leg1->Draw();
	
		
		
	// //******************	
		
		// mycanvas->cd(2);
		// gPad->SetGrid();
		// // gPad->SetLogx();
		// // gPad->SetLogy();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.15);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
		
		// auto mg1 = new TMultiGraph();
		// TGraph *graph2 = new TGraph(100,x,r_2);	
		// TGraph *graph2_g4 = new TGraph(100,x,R_2);	
		
		// graph2->SetMarkerStyle(24);  // red point
		// graph2->SetMarkerSize(1);
		// graph2->SetMarkerColor(kRed);
		// //graph2->SetLineWidth(2);
		// graph2->SetLineColor(kRed);	
		// mg1->Add(graph2);
		
		// graph2_g4->SetMarkerStyle(24);  // red point
		// graph2_g4->SetMarkerSize(1);
		// graph2_g4->SetMarkerColor(kBlue);
		// //graph2_g4->SetLineWidth(2);
		// graph2_g4->SetLineColor(kBlue);	
		// mg1->Add(graph2_g4);
		
		// mg1->Draw("AP");
		// mg1->SetTitle("Maximal difference of fits in region 2 according to Z");		
		// mg1->GetXaxis()->SetTitle("Atomic number Z");
		// mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		// mg1->GetXaxis()->CenterTitle();
		// mg1->GetYaxis()->CenterTitle();
		// mg1->GetXaxis()->SetLimits(1,101);
		// TString rname21 = "Present work (Poly 4)";
		// TString rname22 = "Geant4 10.07 version (Poly 3)";
	
		// TLegend* leg2 = new TLegend(0.15,0.15,0.4,0.35);
		// // leg2->SetTextAlign(12);
		// // leg2->SetFillColor(0);
		// // leg2->SetFillStyle(0);		
		// leg2->SetTextSize(0.04);
		
	
		// leg2->AddEntry(graph2,rname21);
		// leg2->AddEntry(graph2_g4,rname22);
		
		// //leg2->DrawClone("Same");
		// leg2->Draw();
		
	
		// mycanvas->Print("plots/MaximalDifferenceOfFitsofSF_2017_2014WithZ.png");
		// // delete mycanvas;
		// // mycanvas = NULL;
		// // mycanvas->Close();
	



// }

// version for the first publication
void plotMaximalDifferenceOfFittedScatteringFunctionWithZ_2017_2014(){
	
	gROOT->Reset();	
	gSystem->Exec("mkdir -p plots/");
	


	double r_1[100]; 
	double r_2[100]; 
	
	
	double R_1[100]; 
	double R_2[100]; 
	double x[100];
	


	double r1, r2, R1, R2;	
	double sum1, sum2;
	int z;
	std::ostringstream ost;
	ost <<"MaximalDifferenceOfSFFits_2017_2014_final.dat";
	std::ifstream fin(ost.str().c_str());
	for(int i = 0; i<100;i++) // 1612 lines 
	{
		
		fin >> z >> r1 >> r2 >>R1 >> R2;
		x[i] = z;
		r_1[i] = r1;
		r_2[i] = r2;
		R_1[i] = R1;
		R_2[i] = R2;
		sum1+=abs((R1/r1));
		sum2+=abs((R2/r2));
		
		
		// cout<<z<<" "<<r1<<endl;
	}
	printf("factor on average for region 1 = %.9e\n", sum1/100);
	printf("factor on average for region 2 = %.9e\n", sum2/100);
	fin.close();
	
	
	gROOT->Reset();
	
	
	TCanvas* mycanvas = new TCanvas("g","Form Factors",800, 50, 400,400);
		
	mycanvas->SetGrid();
	
	
	
	// gPad->SetLogx();
	// gPad->SetLogy();
	gPad->SetBottomMargin(0.15);
	gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
	auto mg = new TMultiGraph();
	TGraph *graph1 = new TGraph(100,x,r_1);		
	TGraph *graph1_g4 = new TGraph(100,x,R_1);		
		
		
		
	
	//region 3
	graph1->SetMarkerStyle(24);  // red point
	graph1->SetMarkerSize(0.8);
	graph1->SetMarkerColor(kRed);
	//graph1->SetLineWidth(2);
	graph1->SetLineColor(kRed);	
	mg->Add(graph1);	
	//region 3
	
	graph1_g4->SetMarkerStyle(21);  // red point
	graph1_g4->SetMarkerSize(0.8);
	graph1_g4->SetMarkerColor(kBlue);
	//graph1_g4->SetLineWidth(2);
	graph1_g4->SetLineColor(kBlue);	
	mg->Add(graph1_g4);		
		
		// // //set graph parameters of livermore
		
		
	mg->Draw("AP");
			
	// mg->SetTitle("Maximal difference of fits in region 1 according to Z");		
	mg->GetXaxis()->SetTitle("Atomic number Z");
	mg->GetYaxis()->SetTitle("Relative difference (%)");
	
	// mg->GetXaxis()->SetTitleSize(0.06);
	// mg->GetYaxis()->SetTitleSize(0.06);
	
	// mg->GetXaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelOffset(1.3);
	
	mg->GetXaxis()->SetTitleOffset(1.5);
	mg->GetYaxis()->SetTitleOffset(1.5);
		
	mg->GetXaxis()->CenterTitle();
	mg->GetYaxis()->CenterTitle();
	// mg->GetXaxis()->SetLimits(0, 101);
	
	
	TGaxis *axisX = new TGaxis(gPad->GetUxmin(),gPad->GetUymax(),
	gPad->GetUxmax(), gPad->GetUymax(),
	mg->GetXaxis()->GetXmin(),
	mg->GetXaxis()->GetXmax(), 510,"U-");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisX->Draw("");
	
	
	TGaxis *axisY = new TGaxis(gPad->GetUxmax(),gPad->GetUymin(),
	gPad->GetUxmax(), gPad->GetUymax(),
	mg->GetYaxis()->GetXmin(),
	mg->GetYaxis()->GetXmax(), 510,"U+");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisY->Draw();
		
	
	TLegend* leg1 = new TLegend(0.65,0.15,0.9,0.35);
	// leg1->SetTextAlign(12);
	// leg1->SetFillColor(0);
	// leg1->SetFillStyle(0);		
	leg1->SetTextSize(0.04);
	
	TString rname1 = "Present work (Poly 1)";
	TString rname2 = "Geant4 10.07 version (Poly 1)";
	
	
	
	leg1->AddEntry(graph1,rname1);
	leg1->AddEntry(graph1_g4,rname2);
	// leg1->AddEntry(graph14,rname14);
	
	// leg1->AddEntry(graph24,rname24);
	
	// leg1->DrawClone("Same");
	// leg1->Draw();
	
	mycanvas->Print("plots/MaximalDifferenceOfFitsofSF_2017_2014WithZ_Region1.png");
		// delete mycanvas;
		// mycanvas = NULL;
		// mycanvas->Close();	
		
	//******************	
	TCanvas* mycanvas1 = new TCanvas("s","Form Factors",800, 50, 400,400);
		
	mycanvas1->SetGrid();
	
	
	
	// gPad->SetLogx();
	// gPad->SetLogy();
	gPad->SetBottomMargin(0.15);
	gPad->SetLeftMargin(0.15);
	
	
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
		
		auto mg1 = new TMultiGraph();
		TGraph *graph2 = new TGraph(100,x,r_2);	
		TGraph *graph2_g4 = new TGraph(100,x,R_2);	
		
		graph2->SetMarkerStyle(24);  // red point
		graph2->SetMarkerSize(0.8);
		graph2->SetMarkerColor(kRed);
		//graph2->SetLineWidth(2);
		graph2->SetLineColor(kRed);	
		mg1->Add(graph2);
		
		graph2_g4->SetMarkerStyle(21);  // red point
		graph2_g4->SetMarkerSize(0.8);
		graph2_g4->SetMarkerColor(kBlue);
		//graph2_g4->SetLineWidth(2);
		graph2_g4->SetLineColor(kBlue);	
		mg1->Add(graph2_g4);
		
		mg1->Draw("AP");
		// mg1->SetTitle("Maximal difference of fits in region 2 according to Z");		
		mg1->GetXaxis()->SetTitle("Atomic number Z");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		
		mg1->GetXaxis()->SetTitleOffset(1.5);
		mg1->GetYaxis()->SetTitleOffset(1.5);
		
		TGaxis *axisX1 = new TGaxis(gPad->GetUxmin(),gPad->GetUymax(),
		gPad->GetUxmax(), gPad->GetUymax(),
		mg1->GetXaxis()->GetXmin(),
		mg1->GetXaxis()->GetXmax(), 510,"U-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX1->Draw("");
		
		
		TGaxis *axisY1 = new TGaxis(gPad->GetUxmax(),gPad->GetUymin(),
		gPad->GetUxmax(), gPad->GetUymax(),
		mg1->GetYaxis()->GetXmin(),
		mg1->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY1->Draw();
		
		// mg1->GetXaxis()->SetLimits(1,101);
		// TString rname21 = "Present work (Poly 4)";
		// TString rname22 = "Geant4 10.07 version (Poly 3)";
	
		// TLegend* leg2 = new TLegend(0.15,0.15,0.4,0.35);
		// // leg2->SetTextAlign(12);
		// // leg2->SetFillColor(0);
		// // leg2->SetFillStyle(0);		
		// leg2->SetTextSize(0.04);
		
	
		// leg2->AddEntry(graph2,rname21);
		// leg2->AddEntry(graph2_g4,rname22);
		
		// //leg2->DrawClone("Same");
		// leg2->Draw();
		
	
		mycanvas1->Print("plots/MaximalDifferenceOfFitsofSF_2017_2014WithZ_Region2.png");
		// // delete mycanvas;
		// // mycanvas = NULL;
		// // mycanvas->Close();
	



}