TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
  
int results=0;

double RatioMax[100];
void plotSingle(Int_t z, Int_t plot, char*dir)
{
	gStyle->SetLegendTextSize(0.03);
	TString S = sInt(z);  
	
	TString title;
	
	
	if (plot == 1)
	{
		title = "Cross section of EPICS2017 Compton scattering for element Z = " + S;
		
	}
	else if(plot == 2)
	{
		title = "Cross section of EPICS2014 Compton scattering for element Z = " + S;
	}
			
		
	Int_t num = 0;  
	Int_t ncols;
	double e, cs;
	Int_t loop = 0;
	char str[64] = "";
	
	
	FILE * fp = fopen(dir,"r");

	while(1)  
	{	
		loop++;
		// if loop = 1 we read the first header line
		fgets (str, 64, fp);
		// cout<<str<<endl;
		if(loop ==2)
		{
			// now loop = 2, we read the second header line, namely the number of points
			num = stoi(str);  
			cout<<"number of compton effect points:"<<num<<endl;
			break;
		}		
		
	}
	TString Tnum = sInt(num);
	
	double x[num];
	// array for total pair production data: cross section		
	double y[num]; 
	
	for(Int_t i = 0;i<num;++i)
	{
		// read one line energy cross section
		ncols = fscanf(fp,"%lf %lf",&e,&cs); 
		x[i]=e;   // keep energy
		y[i]=cs;  // keep cross section
		// printf("%.9e %.9e\n",x_1[i],y_1[i]);
	}
	fclose(fp);
	
	
    TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",500, 50, 1000, 600);
		

	//TCanvas* mycanvas=new TCanvas(sz, sz, 200, 10, 1000, 1000);
	mycanvas->SetGrid();
	// mycanvas->SetLeftMargin(0.12);
	//mycanvas->SetFillColor(17);
	gPad->SetLogx();
	
	TGraph *graph = new TGraph(num,x,y);
	//graph->Draw("AC*");
	graph->Draw("APL");
	
	graph->SetMarkerStyle(7);  // red point
	graph->SetMarkerSize(2);
	graph->SetMarkerColor(2);
	//graph->SetLineWidth(2);
	graph->SetLineColor(2);
	
	graph->SetTitle(title);
	
	graph->GetXaxis()->SetTitle("Energy (MeV)");
	graph->GetYaxis()->SetTitle("Cross section (barn)");
	
	graph->GetXaxis()->CenterTitle();
	graph->GetYaxis()->CenterTitle();
	
	TLegend* leg = new TLegend(.12,.8,.4,.9);
	// leg->SetFillColor(0);
	leg->SetFillStyle(0);
	// leg->SetTextAlign(22);
	
	
	
	TString name;
	if (plot == 1)
	{
		name = "EPICS2017 - " + Tnum + " points";
		
	}
	else if(plot == 2)
	{
		name = "EPICS2014 - " + Tnum + " points";
	}
	
	
	leg->AddEntry(graph,name);

	leg->Draw();
	
	
	
	
	if (plot == 1)
	{
		mycanvas->Print("plots/epics2017/EPICS2017-ce-cs-" + S + ".png");
		
	}
	else if(plot == 2)
	{
		mycanvas->Print("plots/epics2014/EPICS2014-ce-cs-" + S + ".png");
	}
		
	
	delete mycanvas;
	mycanvas = NULL;	
}

// void plotComparison(Int_t z, char*dir1, char*dir2)
// {
	
	// gROOT->Reset();
		
	// TString S = sInt(z); 
	// TString title;
	// title = "Cross section of Compton scattering for element Z = " + S;
		
		
	// Int_t num1 = 0;  
	// Int_t num2 = 0; 
	
	
	// Int_t ncols;
	// double e, cs;
	// Int_t loop = 0;
	// char str[64] = "";
	
	// FILE * fp1 = fopen(dir1,"r");
	
		// while(1)  
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp1);
			// // cout<<str<<endl;
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num1 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num1<<endl;
				// break;
			// }		
			
		// }
		
		// double x_1[num1];		
		// double y_1[num1]; 
		
		// for(Int_t i = 0;i<num1;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			// x_1[i]=e;   // keep energy
			// y_1[i]=cs;  // keep cross section
			// // printf("%.9e %.9e\n",x_1[i],y_1[i]);
		// }
		// fclose(fp1);
		
		// FILE * fp2 = fopen(dir2,"r");		
		// loop =0;
		
		// while(1)
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp2);
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num2 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num2<<endl;
				// break;
			// }		
			
		// }
		
		// double x_2[num2]; 
		// double y_2[num2]; 
		
		// for(Int_t i = 0;i<num2;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			// x_2[i]=e; // keep energy
			// y_2[i]=cs; // keep cross section
			// //printf("%.9e %.9e\n",x_2[i],y_2[i]);
		// }
		// fclose(fp2);
		
		
		// TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 800, 600);
		
		// mycanvas->SetGrid();
		// mycanvas->Divide(1,2);
		// //TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// // TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// // TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// // pad1->Draw();
		// // pad2->Draw();
		
		// // pad2->cd();
		// // TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// // TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// // pad21->Draw();
		// // pad22->Draw();
		
		
		// mycanvas->cd(1);
		// gPad->SetGrid();
		// gPad->SetLogx();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		
		// //set graph parameters of epics2014
		// graph2->SetMarkerStyle(4);  //blue circle
		// graph2->SetMarkerSize(0.7);
		// graph2->SetMarkerColor(4);
		// graph2->SetLineColor(4);
		
		// graph2->Draw("APL");
	   
		
		// //set graph parameters of EPICS2017
		// graph1->SetMarkerStyle(7);  // red point
		// graph1->SetMarkerSize(2);
		// graph1->SetMarkerColor(2);
		// //graph1->SetLineWidth(2);
		// graph1->SetLineColor(2);	
		// graph1->Draw("PL");
				
		// graph2->SetTitle(title);
		
		// graph2->GetXaxis()->SetTitle("Energy (MeV)");
		// graph2->GetYaxis()->SetTitle("Cross section (barn)");
		
		// graph2->GetXaxis()->SetTitleSize(0.06);
		// graph2->GetYaxis()->SetTitleSize(0.06);
		// graph2->GetYaxis()->SetTitleOffset(0.8);
		// graph2->GetXaxis()->SetTitleOffset(1.3);
		
		// graph2->GetXaxis()->SetLabelSize(0.05);
		// graph2->GetYaxis()->SetLabelSize(0.05);
		
		
		// graph2->GetXaxis()->CenterTitle();
		// graph2->GetYaxis()->CenterTitle();
		
		// graph2->GetXaxis()->SetLimits(1e-6,100000.);
		
		// // graph2->SetMaximum(5e-25); 
		// // graph2->SetMinimum(1e-35); 
		
		
		// TLegend* leg = new TLegend(.12,.7,.35,.9);
		// leg->SetFillColor(0);	
		// leg->SetTextSize(0.04);
		
		
		// TString Tnum1 = sInt(num1);		
		// TString Tnum2 = sInt(num2);	
		
		// TString name1 = "EPICS2017 - "+ Tnum1 + " points";
		// TString name2 = "EPICS2014 - "+ Tnum2 + " points";		
		
		// leg->AddEntry(graph1,name1);
		// leg->AddEntry(graph2,name2);
		// //leg->DrawClone("Same");
		// leg->Draw();
		
		// int flag=0;
		// double r[num2];  // ratio (%): (EPICS2017-Livermore)/Livermore *100 ;
		
		
		// double Ratio = 0.;
		// for(Int_t i=num2-1;i>=0;--i)  //Livermore  
		// {
			// for(Int_t j=num1-1;j>=0;--j) //EPICS2017
			// {
				// if(x_1[j] == x_2[i]) 
				// {				
					// //cout<<flag<<"-----"<<x_2[i]<<endl;
					
					// if(y_2[i] == y_1[j]) //if(i==0)
					// {
						// r[i]=0;
						// //cout<<r[i]<<endl;
					// }
					// else 
					// {
						// r[i] = (y_1[j] - y_2[i])/y_2[i]*100;  //percentage
						// //cout<<x_1[j]<<"====="<<r[i]<<endl;
					// }
					// flag++;
					// //cout<<i<<"-----EPICS2017=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					// break;
				
					// if(abs(r[i])>abs(Ratio))
					// {
						// Ratio = r[i];
					// }	
				// }
			// }
		// }
		
		// RatioMax[z-1] = Ratio;
		
		// if(flag==num2) 
		// {
			// results++;
			// cout<<"flag=="<<flag<<endl;
			// cout<<"flag==num2,winnnnnnnnnnnnnn"<<endl;	
		// }
		
		
		
		// mycanvas->cd(2);
		// gPad->SetLogx();
		// // gPad->SetTopMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetBottomMargin(0.15);
		// // gPad->SetGrid();
		// // gStyle->SetTitleW(0.9);  //per cent of the pad width
		// // gStyle->SetTitleH(0.9);
		// // gStyle->SetTitleFontSize(0.9);
		
		// // // pad21->SetLeftMargin(0.10); //10%
		
		
		// char nameRatio[100] = "Relative difference of EPICS2017 compared to Livermore";	
		
		// TGraph *ratio = new TGraph(num2,x_2,r);
		// ratio->SetTitle(nameRatio);
		// ratio->Draw();
		// ratio->GetXaxis()->SetTitle("Energy (MeV)");
		// ratio->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// ratio->GetXaxis()->SetTitleSize(0.06);
		// ratio->GetYaxis()->SetTitleSize(0.06);
		
		// ratio->GetXaxis()->SetLabelSize(0.05);
		// ratio->GetYaxis()->SetLabelSize(0.05);
		// ratio->GetYaxis()->SetTitleOffset(0.8);
		// ratio->GetXaxis()->SetTitleOffset(1.3);
		
		// ratio->GetXaxis()->CenterTitle();
		// ratio->GetYaxis()->CenterTitle();
		
		// ratio->SetMarkerStyle(8);
		// ratio->SetMarkerSize(0.5);
		// ratio->SetMarkerColor(2);
		// ratio->SetLineColor(2);
		
		// TLegend* leg21 =  new TLegend(0.5,0.2,0.9,0.4,"RD = #frac{EPICS2017-EPICS2014}{EPICS2014} x 100");
		// leg21->SetTextAlign(22);
		// leg21->SetFillStyle(0);
		// leg21->Draw();
		// leg21->SetTextSize(0.05);
		
		
		// // TLegend* leg212 =  new TLegend(0.12,0.7,0.3,0.88);
		// // TString Tnum4 = sInt(num2);
		// // TString name4 = Tnum4 + " points in comparison";		
		// // leg212->AddEntry(ratio,name4);
		// // leg212->SetTextAlign(22);
		// // leg212->SetFillStyle(0);
		// // leg212->Draw();
		// // leg212->SetTextSize(0.05);
		
		
		
		
		// //***********(begin)for the zoomin of the ratio 
		
		
		
		// mycanvas->Print("plots/comparison/comparison-ce-cs-"+ S +".png");
		// mycanvas->Close();
		
		
// }

// for the first publication
void plotComparison_for_publication(Int_t z, char*dir1, char*dir2)
{
	
	gROOT->Reset();
		
	TString S = sInt(z); 
	TString title;
	title = "Cross section of Compton effect for element Z = " + S;
		
		
	Int_t num1 = 0;  
	Int_t num2 = 0; 
	
	
	Int_t ncols;
	double e, cs;
	Int_t loop = 0;
	char str[64] = "";
	
	FILE * fp1 = fopen(dir1,"r");
	
		while(1)  
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp1);
			// cout<<str<<endl;
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num1 = stoi(str);  
				// cout<<"number of total pair production points:"<<num1<<endl;
				break;
			}		
			
		}
		
		double x_1[num1];		
		double y_1[num1]; 
		
		for(Int_t i = 0;i<num1;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			x_1[i]=e;   // keep energy
			y_1[i]=cs;  // keep cross section
			// printf("%.9e %.9e\n",x_1[i],y_1[i]);
		}
		fclose(fp1);
		
		FILE * fp2 = fopen(dir2,"r");		
		loop =0;
		
		while(1)
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp2);
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num2 = stoi(str);  
				// cout<<"number of total pair production points:"<<num2<<endl;
				break;
			}		
			
		}
		
		double x_2[num2]; 
		double y_2[num2]; 
		
		for(Int_t i = 0;i<num2;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			x_2[i]=e; // keep energy
			y_2[i]=cs; // keep cross section
			//printf("%.9e %.9e\n",x_2[i],y_2[i]);
		}
		fclose(fp2);
		
		
		TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",800, 50, 400, 400);
		
		mycanvas->SetGrid();
		// mycanvas->Divide(1,2);
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		// mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
		auto mg = new TMultiGraph();		
		TGraph *graph1 = new TGraph(num1,x_1,y_1);
		TGraph *graph2 = new TGraph(num2,x_2,y_2);
		
		//set graph parameters of EPICS2017
		graph1->SetMarkerStyle(24);  // red point
		graph1->SetMarkerSize(1.4);
		graph1->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		// graph1->SetLineColor(kRed);	
		mg->Add(graph1);
		
		//set graph parameters of livermore
		graph2->SetMarkerStyle(21);  //blue circle
		graph2->SetMarkerSize(0.8);
		graph2->SetMarkerColor(kBlue);
		graph2->SetLineColor(kBlue);
		
		mg->Add(graph2);
		mg->Draw("AP");
		mg->SetTitle(title);
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Cross section (barn)");
		
		// mg->GetXaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleOffset(0.8);
		// mg->GetXaxis()->SetTitleOffset(1.3);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		mg->GetXaxis()->SetTitleOffset(1.5);
		mg->GetYaxis()->SetTitleOffset(2);
		
		// mg->GetXaxis()->SetLimits(1e-6,100000.);
		
		// graph2->SetMaximum(5e-25); 
		// graph2->SetMinimum(1e-35); 
		
		
		TGaxis *axisX = new TGaxis(TMath::Power(10, gPad->GetUxmin()),gPad->GetUymax(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg->GetXaxis()->GetXmin(),
		mg->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw();
		
		
		TGaxis *axisY = new TGaxis(TMath::Power(10, gPad->GetUxmax()),gPad->GetUymin(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg->GetYaxis()->GetXmin(),
		mg->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
		
		
		TLegend* leg = new TLegend(.15,.7,.4,.9);
		leg->SetFillColor(0);	
		// leg->SetTextSize(0.06);
		
		TString Tnum1 = sInt(num1);		
		TString Tnum2 = sInt(num2);	
		
		// TString name1 = "EPICS2017 - "+ Tnum1 + " points";
		// TString name2 = "Livermore - "+ Tnum2 + " points";		
		
		TString name1 = "EPICS2017";
		TString name2 = "EPDL97";	
		
		leg->AddEntry(graph1,name1);
		leg->AddEntry(graph2,name2);
		//leg->DrawClone("Same");
		leg->Draw();
		
		
		
		
		
		mycanvas->Print("plots/comparison/comparison-ce-cs-"+ S +".png");
		mycanvas->Close();
		
		
}





void plot_cs(){
	
	gROOT->Reset();
	// create the 2 directories if they do not existif
	string dirs[4] = {"plots","epics2014","epics2017","comparison"};
	gSystem->Exec("mkdir -p plots/epics2014");
	gSystem->Exec("mkdir -p plots/epics2017");
	gSystem->Exec("mkdir -p plots/comparison");
	
	for(int i =0; i<100; i++)
	{
		RatioMax[i] = 0;
	}		
    
	for (Int_t z = 1;z<=100;++z)// number of element Z, from 1 to 100
	{
		// if((z != 1) && (z != 13) && (z != 82)) continue;
	
		
		char path1Format[128] = "epics2017/compCS/ce-cs-%d.dat"; //prefix of the name of original data file
		char path1[128];
		
		char path2Format[128] = "epics2014/compCS/ce-cs-%d.dat"; //prefix of the name of original data file
		char path2[128];
		
		sprintf(path1,path1Format, z);
		sprintf(path2,path2Format, z);
		
		// plotSingle(z,1,path1);
		// plotSingle(z,2,path2);			
		// plotComparison(z, path1, path2);
		plotComparison_for_publication(z, path1, path2);
		
			
	}
	
	
	FILE* out = fopen("MaximalDifferenceOfCSBetween2014And2017.dat", "w"); // for plotting

    for(int i=0; i<100;i++)
	{
		fprintf(out,"%d %.9e\n", i+1,RatioMax[i]);
		
	}
		
	fclose(out);
	
	cout<<"results="<<results<<endl;
}